/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with the program; if not, see <http://www.gnu.org/licenses/>  
 *
 *
 * Authors:
 *		Michel Zucchi <notzed@ximian.com>
 *		Neil Jagdish Patel <neil.patel@canonical.com> (copy-and-paste counts too!)
 *
 * Copyright (C) 1999-2008 Novell, Inc. (www.novell.com)
 *
 */

/*
 *
 * THIS IS A MAJOR HACK -- DO NOT EMAIL ME ABOUT HOW MAJOR OF A HACK IT REALLY
 * IS. I'M ALREADY LOSING SLEEP OVER IT.
 *
 * IF YOU HAVE ISSUES WITH THIS CODE, FEEL FREE TO ADD _PROPER_ PLUGIN SUPPORT
 * TO EVOLUTION, OR AT LEAST A DBUS INTERFACE.
 *
 * -- 
 * this message was brought to you by Holiday Inn coffee and a cold
 * Berlin morning 
 *
 */

#ifndef _MY_HACKY_E_SHELL_H_
#define _MY_HACKY_E_SHELL_H_

#include <e-util/e-config.h>
#include <mail/em-utils.h>
#include <mail/em-event.h>
#include <mail/em-folder-tree-model.h>
#include <shell/evolution-config-control.h>
#include <shell/e-component-view.h>
#include <shell/es-event.h>

typedef struct _EShell EShell;
typedef struct _EShellPrivate EShellPrivate;
typedef enum _EShellLineStatus EShellLineStatus;

enum _EShellLineStatus {
	E_SHELL_LINE_STATUS_ONLINE,
	E_SHELL_LINE_STATUS_GOING_OFFLINE, /* NB: really means changing state in either direction */
	E_SHELL_LINE_STATUS_OFFLINE,
	E_SHELL_LINE_STATUS_FORCED_OFFLINE
};

struct _EShellPrivate {
	/* IID for registering the object on OAF.  */
	char *iid;

	GList *windows;

	/* EUriSchemaRegistry *uri_schema_registry; FIXME */
	void *component_registry;

	/* Names for the types of the folders that have maybe crashed.  */
	/* FIXME TODO */
	GList *crash_type_names; /* char * */

	/* Line status and controllers  */
	EShellLineStatus line_status;
	int line_status_pending;
	EShellLineStatus line_status_working;
	void *line_status_listener;

	/* Settings Dialog */
	union {
		GtkWidget *widget;
		gpointer pointer;
	} settings_dialog;

	/* If we're quitting and things are still busy, a timeout handler */
	guint quit_timeout;

	/* Whether the shell is succesfully initialized.  This is needed during
	   the start-up sequence, to avoid CORBA calls to do make wrong things
	   to happen while the shell is initializing.  */
	unsigned int is_initialized : 1;

	/* Wether the shell is working in "interactive" mode or not.
	   (Currently, it's interactive IIF there is at least one active
	   view.)  */
	unsigned int is_interactive : 1;

	/* Whether quit has been requested, and the shell is now waiting for
	   permissions from all the components to quit.  */
	unsigned int preparing_to_quit : 1;

	/* Whether we are recovering from a crash in the previous session. */
	unsigned int crash_recovery : 1;
};

struct _EShell {
	BonoboObject parent;

	EShellPrivate *priv;
};

#endif
